package org.pnyka.components.core.keyholder;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.generators.ElGamalKeyPairGenerator;
import org.bouncycastle.crypto.params.ElGamalKeyGenerationParameters;
import org.bouncycastle.crypto.params.ElGamalParameters;
import org.bouncycastle.crypto.params.ElGamalPrivateKeyParameters;
import org.bouncycastle.crypto.params.ElGamalPublicKeyParameters;
import org.pnyka.database.Database;
import org.pnyka.database.DatabaseQueries;

public class KeyHolderCreator 
{
    public KeyHolder createKeyHolder(int id, ElGamalParameters params)
    {   
        SecureRandom sr = new SecureRandom();
        
        ElGamalKeyGenerationParameters keygenparam = new ElGamalKeyGenerationParameters(sr, params);
        ElGamalKeyPairGenerator keyPairGen = new ElGamalKeyPairGenerator();
        keyPairGen.init(keygenparam);
        
        AsymmetricCipherKeyPair keypair = keyPairGen.generateKeyPair(); 
        ElGamalPublicKeyParameters myPubKeyParams = (ElGamalPublicKeyParameters)keypair.getPublic();
        ElGamalPrivateKeyParameters myPrivKeyParams = (ElGamalPrivateKeyParameters)keypair.getPrivate();
        storeKeyPair(id, myPubKeyParams,  myPrivKeyParams);
        
        return new KeyHolder(id, myPubKeyParams, myPrivKeyParams);
    }
    
    //PROSWRINO: h apothikefsh twn kleidiwn ginetai sth vash
    ////apothikefsh kai twn parametrwn
    private void storeKeyPair(int id, ElGamalPublicKeyParameters myPubKeyParams, ElGamalPrivateKeyParameters myPrivKeyParams)
    {
        boolean executed = false;
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        String sqlText  = "INSERT INTO keyholders_keys (keyholder_id, public_key, private_key) VALUES ('" + id + "','" + myPubKeyParams.getY()+ "', '"+ myPrivKeyParams.getX()+"')";

        try
        {
            Statement sql = conn.createStatement();
            executed = sql.execute(sqlText);
        }
        catch(SQLException e){}
    }
    
    //retrieves ElGamal Parameters
    public static ElGamalParameters getElGamalParameters()
    {
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        ElGamalParameters params = null;
        
        try
        {
            ResultSet parameters = DatabaseQueries.selectAllFromTable(conn, "parameters");
            if(DatabaseQueries.countRows(parameters) == 0)
                return  new ElGamalParameters(BigInteger.ZERO, BigInteger.ZERO);
            else
            {                
                BigInteger p = parameters.getBigDecimal("parameter_p").toBigInteger();
                BigInteger g = parameters.getBigDecimal("parameter_g").toBigInteger();

                params = new ElGamalParameters(p, g);
            }          
        }
        catch(SQLException e){}
        
        return params;
    }
      
}
