package org.pnyka.cryptolib.Signatures;

import java.math.BigInteger;
import org.pnyka.cryptolib.crypto.CipherText;

/** 
 * Class of objects represent signed messages  
 */
public class SignedMessage 
{
    private CipherText cipher;
    private BigInteger[] sign;
    
    /** 
     * Creates a new instance of SignedMessage 
     */
    public SignedMessage(CipherText cipher, BigInteger[] sign) 
    {
        this.cipher = cipher;
        this.sign = sign;   
    }
       
    
    /**
     * Returns the the cipher.
     * @return cipher 
     */
    public CipherText getCipher()
    {
        return cipher;
    }
        
     /**
     * Returns the signature of the cipher.
    * @return sign the signature of the cipher.
     */
    public BigInteger[] getSign()
    {
        return sign;
    }
    
}
