package org.pnyka.components.core.votemanager;

public class ProtocolParameters
{    
    public boolean voteReEncryption;
    public boolean zkpVoteValidity;
    public boolean zkpVoteReencValidity;
    public boolean timestamp;
    public boolean signature;
    
   /**
     * Creates a new instance of ProtocolParameters
     * 
     * @param voteReEncryption if true, the vote must be reencrypted
     * @param zkpVoteValidity if true, the vote validity must be proven
     * @param zkpVoteReencValidity if true, the reencryption validity must be proven
     * @param timestamp if true, the vote is timestamped
     * @param signature if true, the vote is signed
     */
    public ProtocolParameters( boolean voteReEncryption,
                               boolean zkpVoteValidity,
                               boolean zkpVoteReencValidity,
                               boolean timestamp,
                               boolean signature )
    {
        this.voteReEncryption = voteReEncryption;
        this.zkpVoteValidity = zkpVoteValidity;
        this.zkpVoteReencValidity = zkpVoteReencValidity;
        this.timestamp = timestamp;
        this.signature = signature;
    }
}
