package org.pnyka.cryptolib.crypto;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.Date;
import org.bouncycastle.crypto.generators.ElGamalParametersGenerator;
import org.bouncycastle.crypto.params.ElGamalParameters;

/**
 * Class for ElGamal encryption algorithm parameters
 */
public class Parameters 
{    
    private int size;
    public ElGamalParameters params = null;
    
    public Parameters(int size)
    {
        this.size = size;
    }
   /**
    * Generates p and g parameters of ElGamal algorithm.
    * @param size size in bits of parameters 
    * @return p, g parameters
    */
   public ElGamalParameters generateElGamalParameters()
   {
       SecureRandom sr = null;
       
      
        byte[] randomBytes = new byte[size];
        sr = new SecureRandom();
        sr.generateSeed(size);
        sr.nextBytes(randomBytes);
           
        ElGamalParametersGenerator paramgen = new ElGamalParametersGenerator();
        paramgen.init(size, 1, sr);
        
        do
        {
            params = paramgen.generateParameters();//parameters generation
        } 
        while( params.getG().compareTo(BigInteger.ZERO) != 1 );//while g!=0
               
        return params;
   } 
   
    
}