package org.pnyka.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Properties;
import org.pnyka.util.PropertiesFiles;

public class Database
{

   //db_name_property: the name of the database is first defined in the properties file
   //db_username_property: the username of the database is first defined in the properties file
   //db_psw_property: the password of the database is first defined in the properties file
   public static Connection connectDatabase(String db_name_property, String db_username_property, String db_password_property, String host_ip_property)
   {
       String databaseName, username, psw, ip; //input
       Connection conn = null; //output
       
       PropertiesFiles pf = new PropertiesFiles();
       Properties properties = pf.ReadProperties("system.properties");
       databaseName = properties.getProperty(db_name_property);
       username = properties.getProperty(db_username_property);
       psw = properties.getProperty(db_password_property);
       ip = properties.getProperty(host_ip_property);
       
       try
       {
           Class.forName("org.postgresql.Driver"); //load the driver
           conn = DriverManager.getConnection("jdbc:postgresql://"+ip+":5432/"+databaseName, username, psw); //connect to db

       }
       catch(ClassNotFoundException e1)
       {
           e1.printStackTrace();
       }
       catch(SQLException e2)
       {
           e2.printStackTrace();
       }
             
       return conn;        
   }  
   
  }
