package org.pnyka.util;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

public class PropertiesFiles 
{
    // Read properties file.
    public Properties ReadProperties(String filename)
    {   
        Properties p = null;
        
        try 
        {
            ResourceBundle bdl = new PropertyResourceBundle(new FileInputStream(getLocalDirName() + "/" + filename));
            
            p = new Properties();
            Enumeration keys = bdl.getKeys();            

            while(  keys.hasMoreElements( ) ) 
            {
                String prop = (String)keys.nextElement( );
                String val = bdl.getString(prop); 
                p.setProperty(prop, val);
            }                        
         }
         catch(Exception e)
         {          
               e.printStackTrace();
         }

         return p;
        
    }
       
    // Write properties file.
    public static void WriteProperties(String filename, Properties properties)
    {
        try 
        {           
            properties.store(new FileOutputStream(filename), null);
        }
        catch (IOException e)
        {
        }
    }
    
    public String getLocalDirName()
    {
        String localDirName;      
        //Use that name to get a URL to the directory we are executing in
        java.net.URL myURL = this.getClass().getResource(getClassName());  //Open a URL to the our .class file      

        //Clean up the URL and make a String with absolute pathname
        localDirName = myURL.getPath();  //Strip path to URL object out
        localDirName = myURL.getPath().replaceAll("%20", "");  //change %20 chars to spaces      

        //Get the current execution directory
        localDirName = localDirName.substring(0,localDirName.lastIndexOf("/"));  //clean off the file name      

        return localDirName;
    }
    
    public String getClassName()
    {
        String thisClassName;      
        
         //Build a string with executing class's name
         thisClassName = this.getClass().getName();
         thisClassName = thisClassName.substring(thisClassName.lastIndexOf(".") + 1,thisClassName.length());
         thisClassName += ".class";  //this is the name of thebytecode file that is executing      
         
         return thisClassName;
   }
 
    public static void main(String[] args)
    {
        PropertiesFiles pf = new PropertiesFiles();
        Properties properties = pf.ReadProperties("ea.properties");
        String ea_code = properties.getProperty("EA_CODE");
    }
    
}
