package org.pnyka.components.administrator;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import org.pnyka.database.Database;
import org.pnyka.database.DatabaseQueries;

//The class contains all functions needed for system initialization
public class SystemInitialization
{
    //Stores central EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local, description are set)    
    public static boolean DefineCentralEA(String computer_name, String machine_ip, String url, String vote_area, boolean is_central, boolean is_local, String description)
    {
        return DefineEA(computer_name, machine_ip, url, vote_area, is_central, is_local, description);
    }
    //Stores central EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local are set)
    public static boolean DefineCentralEA(String computer_name, String machine_ip, String url, String vote_area, boolean is_central, boolean is_local)
    {
       return DefineEA(computer_name, machine_ip, url, vote_area, is_central, is_local);
    }
    //Stores central EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local, description are set)
    public static boolean DefineCentralEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local, String description)
    {
       return DefineEA(computer_name, machine_ip, url, is_central, is_local, description);
    }
    //Stores central EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local are set)
    public static boolean DefineCentralEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local)
    {
       return DefineEA(computer_name, machine_ip, url, is_central, is_local);
    }
    
    
    
    //Stores local EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local, description are set)    
    public static boolean DefineLocalEA(String computer_name, String machine_ip, String url, String vote_area, boolean is_central, boolean is_local, String description)
    {
        return DefineEA(computer_name, machine_ip, url, vote_area, is_central, is_local, description);
    }
    //Stores central EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local are set)
    public static boolean DefineLocalEA(String computer_name, String machine_ip, String url, String vote_area, boolean is_central, boolean is_local)
    {
       return DefineEA(computer_name, machine_ip, url, vote_area, is_central, is_local);
    }    
    //Stores local EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local, description are set)
    public static boolean DefineLocalEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local, String description)
    {
       return DefineEA(computer_name, machine_ip, url, is_central, is_local, description);
    }
    //Stores local EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local are set)
    public static boolean DefineLocalEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local)
    {
       return DefineEA(computer_name, machine_ip, url, is_central, is_local);
    }
    
    //Returns the number of local EAs
    public static int NumberofLocalEAs()
    {
        int number_of_local_eas = 0;
        
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
        try 
        {            
            Statement stm = conn.createStatement();
            
            String query = "SELECT * FROM ea_definition WHERE is_local = TRUE";
            number_of_local_eas = DatabaseQueries.countRows(DatabaseQueries.selectFromTable(conn, query));
                        
            return number_of_local_eas;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            return -1;
        }   
    }
    
    //Stores keyholders' data in the database (fields kh_name and description are set)
    public static boolean DefineKeyholders(String kh_name, String description)
    {

        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
        try 
        {            
            Statement stm = conn.createStatement();

            String query = null;
            
            if(description == null)
                query = "INSERT INTO keyholders (kh_name) VALUES ('" +kh_name+ "')";
            else 
                query = "INSERT INTO keyholders (kh_name, description) VALUES ('" +kh_name+ "', '" +description+ "')";
            
            int ret = stm.executeUpdate(query);

            if(ret == 1)
                return true;
            else
                return false;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            ex.printStackTrace();
            return false;
        } 
    }
    
        
    //Stores EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local, description are set)    
    private static boolean DefineEA(String computer_name, String machine_ip, String url, String vote_area, boolean is_central, boolean is_local, String description)
    {
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
        try 
        {     
            //if there is one central EA, donn't allow the insertion of a second
            if(is_central == true)
            {
                ResultSet  central_ea = DatabaseQueries.selectFromTable(conn, "SELECT * FROM ea_definition WHERE is_central = TRUE");
                int count_central_ea = DatabaseQueries.countRows(central_ea);
        
                if( count_central_ea == 1 )
                    return false;
            }
            
            Statement stm = conn.createStatement();
            String query = "INSERT INTO ea_definition (computer_name, machine_ip, url, vote_area, is_central, is_local, description) VALUES ('" +computer_name+ "','" +machine_ip+ "','" +url+ "','" +vote_area+ "','" +is_central+ "','" +is_local+ "','" +description+ "')";
            int ret = stm.executeUpdate(query);

            if(ret == 1)
                return true;
            else
                return false;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            ex.printStackTrace();
            return false;
        }        
    }
    
    //Stores EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local, description are set)    
    private static boolean DefineEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local, String description)
    {
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
        try 
        {            
            //if there is one central EA, donn't allow the insertion of a second
            if(is_central == true)
            {
                ResultSet  central_ea = DatabaseQueries.selectFromTable(conn, "SELECT * FROM ea_definition WHERE is_central = TRUE");
                int count_central_ea = DatabaseQueries.countRows(central_ea);
        
                if( count_central_ea == 1 )
                    return false;
            }
            
            Statement stm = conn.createStatement();
            String query = "INSERT INTO ea_definition (computer_name, machine_ip, url, is_central, is_local, description) VALUES ('" +computer_name+ "','" +machine_ip+ "','" +url+ "','" +is_central+ "','" +is_local+ "','" +description+ "')";
            int ret = stm.executeUpdate(query);

            if(ret == 1)
                return true;
            else
                return false;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            ex.printStackTrace();
            return false;
        }        
    }
    
    //Stores EA's data in the database (fields computer_name, machine_ip, url, is_central, is_local are set)    
    private static boolean DefineEA(String computer_name, String machine_ip, String url, boolean is_central, boolean is_local)
    {
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
        
        try 
        {   
            //if there is one central EA, donn't allow the insertion of a second
            if(is_central == true)
            {
                ResultSet  central_ea = DatabaseQueries.selectFromTable(conn, "SELECT * FROM ea_definition WHERE is_central = TRUE");
                int count_central_ea = DatabaseQueries.countRows(central_ea);
        
                if( count_central_ea == 1 )
                    return false;
            }
            
            Statement stm = conn.createStatement();
            String query = "INSERT INTO ea_definition (computer_name, machine_ip, url, is_central, is_local) VALUES ('" +computer_name+ "','" +machine_ip+ "','" +url+ "','" +is_central+ "','" +is_local+ "')";
            int ret = stm.executeUpdate(query);

            if(ret == 1)
                return true;
            else
                return false;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            ex.printStackTrace();
            return false;
        }        
    }
    
    //Stores EA's data in the database (fields computer_name, machine_ip, url, vote_area, is_central, is_local are set)    
    private static boolean DefineEA(String computer_name, String machine_ip, String url, String vote_area,  boolean is_central, boolean is_local)
    {
        Connection conn = Database.connectDatabase("DB_NAME0", "DB_USERNAME0", "DB_PASSWORD0", "DB_HOST0");
                        
        try 
        {      
            //if there is one central EA, donn't allow the insertion of a second
            if(is_central == true)
            {
                ResultSet  central_ea = DatabaseQueries.selectFromTable(conn, "SELECT * FROM ea_definition WHERE is_central = TRUE");
                int count_central_ea = DatabaseQueries.countRows(central_ea);
        
                if( count_central_ea == 1 )
                    return false;
            }
            
            Statement stm = conn.createStatement();
            String query = "INSERT INTO ea_definition (computer_name, machine_ip, url, vote_area, is_central, is_local) VALUES ('" +computer_name+ "','" +machine_ip+ "','" +url+ "','" +vote_area+ "','" +is_central+ "','" +is_local+ "')";
            int ret = stm.executeUpdate(query);

            if(ret == 1)
                return true;
            else
                return false;
        }
        catch (SQLException ex)
        {
            System.out.println("Problem with a transaction");
            ex.printStackTrace();
            return false;
        }        
    } 
}
