package org.pnyka.cryptolib.crypto;

import java.io.Serializable;
import java.math.BigInteger;

/**
 * Class for the initial unencrypted message.
 */
public class PlainText implements Serializable
{
    private BigInteger M; // plaintext
    /**
    * Constructor
    * 
    * @param x
    */
    public PlainText(BigInteger M)
    {
        this.M = M;
    }
    
    /**
     * @return cleartext x.
     */
    public BigInteger getM()
    {
        return M;
    }

   
     
     /**
      * Does byte stuffing to a byte array that corresponds to a BigInteger
      * @param in the byte array of a big integer
      * @param size the final length of the array
      * @return the byte array of the passed BigInteger
      */
     public byte[] byteStuffing(byte[] in, int size)
     {
         byte[] out = new byte[size];
         System.arraycopy(in, 0, out, out.length-in.length, in.length);
         for(int i = 0; i<out.length-in.length; i++)
         out[i] = (byte)0;
        
         return out;        
     }
}