package org.pnyka.cryptolib.prng;

import java.math.BigInteger;

/**
 * Interface for random number generators.
 */
public interface RandomGenerator 
{
    /**
     * Returns a random number
     *
     * See also java.util.Random#next
     * @param numBits the length in bits of random number
     * @return a random Biginteger
     */
    public BigInteger nextNumber(int numBits);
  
}
