package org.pnyka.timestamper;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.bouncycastle.tsp.TSPException;
import org.bouncycastle.tsp.TimeStampRequest;
import org.bouncycastle.tsp.TimeStampResponse;

public class TimestampExchange
{
   public void SendTimestampRequest(TimeStampRequest request, ObjectOutputStream out) throws IOException
   {
        byte[] requestEnc = request.getEncoded();//h EA dhmiourgei thn ASN1 encodable ekdosh tou request pou sxhmatise kai prepei na steilei sthn TSA
        out.writeObject(requestEnc);
   }
   
   public TimeStampRequest ReceiveTimestampRequest(ObjectInputStream in) throws IOException, ClassNotFoundException 
   {
       byte[] reqEnc = (byte[])in.readObject();
       
       return new TimeStampRequest( reqEnc );//
   }

   
    public void SendTimestampResponse(TimeStampResponse response, ObjectOutputStream out) throws IOException 
   {
        byte[] respEnc = response.getEncoded();//h EA dhmiourgei thn ASN1 encodable ekdosh tou request pou sxhmatise kai prepei na steilei sthn TSA
        out.writeObject(respEnc);
   }
   
   public TimeStampResponse ReceiveTimestampResponse(ObjectInputStream in) throws IOException, TSPException, ClassNotFoundException 
   {
       byte[] respEnc = (byte[])in.readObject();
       
       return new TimeStampResponse( respEnc );//
   }
}
    
  