<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="org.pnyka.database.*, java.sql.*, java.math.*, org.pnyka.components.keyholder.*, org.bouncycastle.crypto.params.*, org.pnyka.cryptolib.crypto.Parameters"%>
<%@page import="org.pnyka.components.tallier.Tallier" %>
<%@page import="org.pnyka.cryptolib.crypto.CipherText, org.pnyka.cryptolib.math.*, org.pnyka.cryptolib.crypto.PlainText" %>
<%@page import="java.io.*, java.text.*, org.pnyka.util.Validation" %>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<head>
	<title>ΔΙΑΧΕΙΡΙΣΗ ΣΥΣΤΗΜΑΤΟΣ "ΠΝΥΚΑ"</title>
	<link rel="stylesheet" href="style_admin.css" type="text/css"/>
</head>

<body>    
	<div id="wrapper">	
            <div id="header">
                <div style="position: relative; top:35px" id="navigation">
                        <ul>
                            <li><a href="Logout.jsp" >Αποσύνδεση</a></li>
                        </ul>
                    </div>                   
                <img style="position:relative; top: 13px" src="images/e-pnyka.bmp" alt="logos"/>		  
            </div>
        <div id="content">
         
             <%//LOCAL ADMIN
             ResultSet config_elections = null;
             Connection conn = Database.connectCentralDatabase();//ta orismata afta tha vriskontai se config file
             Connection conn_local = Database.connectLocalDatabase();//ta orismata afta tha vriskontai se config file
             int valid_date_time = Validation.validateDateAndTime("tallier");
             
             if(valid_date_time == 2)
              {
                ResultSet tallier_rs = DatabaseQueries.selectAllFromTable(conn_local, "tallier");
                int tallier_rows = DatabaseQueries.countRows(tallier_rs);
                
                if(tallier_rows == 0)
                {
                    try
                    {                     
                        config_elections = DatabaseQueries.selectAllFromTable(conn, "config_elections");
                        config_elections.next();         
                    }
                    catch(SQLException e){}

                    Tallier tallier = new Tallier();
                    tallier.homomorphicAdd();
                    tallier.publishEncryptedResults();

                    ResultSet encrypted_result = null;

                    try
                    {
                        encrypted_result = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM tallier ORDER BY candidate_id");

                        CipherText part;
                        PlainText plain;  

                        ResultSet kh = DatabaseQueries.selectAllFromTable(conn, "keyholders");
                        KeyHolder[] newKHArr = new KeyHolder[DatabaseQueries.countRows(kh)];

                        ResultSet params1 = DatabaseQueries.selectAllFromTable(conn, "parameters");
                        params1.next();
                        ElGamalParameters prms = new ElGamalParameters(((BigDecimal)params1.getObject("parameter_p")).toBigInteger(), ((BigDecimal)params1.getObject("parameter_g")).toBigInteger());

                        for(int i=0; i<newKHArr.length; i++)
                        {
                            ResultSet keyholder = DatabaseQueries.selectFromTable(conn, "SELECT * FROM keyholders_keys WHERE keyholder_id ='"+(i+1)+"' ");
                            keyholder.first();
                            ElGamalPublicKeyParameters myPubKeyParams = new ElGamalPublicKeyParameters (((BigDecimal)keyholder.getObject("public_key")).toBigInteger(), prms);
                            ElGamalPrivateKeyParameters myPrivKeyParams = new ElGamalPrivateKeyParameters(((BigDecimal)keyholder.getObject("private_key")).toBigInteger(), prms);
                            newKHArr[i] = new KeyHolder(i+1, myPubKeyParams, myPrivKeyParams);

                        } 


                        while(encrypted_result.next())
                        { 
                             BigInteger z = encrypted_result.getBigDecimal("enc_res_z").toBigInteger();
                             BigInteger c = encrypted_result.getBigDecimal("enc_res_c").toBigInteger();

                             CipherText encResult = new CipherText(z, c);

                             part = encResult;

                             for(int i=0; i<newKHArr.length-1; i++)
                             {
                                part = newKHArr[i].DecryptPart(part);
                             }

                             plain = newKHArr[newKHArr.length-1].Decrypt(part);

                             int candidate_id = encrypted_result.getInt("candidate_id");
                             ResultSet config_candidates = DatabaseQueries.selectFromTable(conn_local, "SELECT * FROM config_candidates WHERE candidate_id ='"+candidate_id+"' ");
                             config_candidates.next();
                             int candidate_m = config_candidates.getInt("candidate_m");                 

                             BigInteger result = DiscreteLog.bruteForce(BigInteger.valueOf(candidate_m), plain.getM(), prms.getP());

                             int m = candidate_m;
                             int r = result.mod(prms.getP().subtract(BigInteger.ONE)).intValue();
                             tallier.publishResults(m, r);
                          }

                    }
                   catch(SQLException e){ } 

                  out.print("<div id='message'><br><br><br>Τα τοπικά συγκεντρωτικά αποτελέσματα υπολογίστηκαν και αποθηκεύτηκαν στη βάση.<br></div>");
                  out.print("<br><a style='font-size:15px' href='Results.jsp?istallier=yes'>Αποτελέσματα</a><br>");
                  out.print("<br><a style='font-size:15px' href='Administrator.jsp?username=admin&password=admin'>Πίσω</a><br><br><br><br><br>");
            }
            else
            {
                out.print("<div id='message'><br><br><br>Τα τοπικά συγκεντρωτικά αποτελέσματα υπολογίστηκαν ήδη.</div>");
                out.print("<br><a style='font-size:15px' href='Results.jsp?istallier=yes'>Αποτελέσματα</a>");
                out.print("<br><br><a style='font-size:15px' href='Administrator.jsp?username=admin&password=admin'>Πίσω</a>");
             }
        }
        else
        {
            out.print("<div id='message'><br><br><br>Η ψηφοφορία δεν έχει λήξει.</div>");
            out.print("<br><br><a style='font-size:15px' href='Administrator.jsp?username=admin&password=admin'>Πίσω</a>");
        }
            
    %>
    
  
     </div>
                                
     <div id="footer"><br><br><br><br>
     2007 &copy; System Administrator    
     </div>
                                             
	
    </div>
        
    </body>
</html>
